/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2022 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.shell;

import java.util.stream.Collectors;

import org.apache.karaf.shell.api.action.Action;
import org.apache.karaf.shell.api.action.Command;
import org.apache.karaf.shell.api.action.lifecycle.Service;
import org.apache.karaf.shell.support.table.ShellTable;

import ru.entaxy.platform.base.objects.factory.EntaxyFactory.OutputInfo;

@Service
@Command(scope = EntaxyProducerServiceSupport.SCOPE, name = "factory-outputs")
public class FactoryOutputs extends FactoryAwareCommand implements Action {

	@Override
	protected Object doExecute() throws Exception {
		
		ShellTable table = new ShellTable();
		table.column("Type");
		table.column("Generator");
		table.column("Scopes");
		
		for (OutputInfo oi: entaxyFactory.getOutputs()) {
			table.addRow().addContent(
				oi.getType(),
				oi.getGenerator(),
				oi.getScopes().stream().collect(Collectors.joining(","))
					);
		}
		
		table.print(System.out);
		
		return null;
	}

}
